//+------------------------------------------------------------------+
//|                         Test_StopLoss_Level_in_PendingOrders.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property description "      StopLoss"
#include <Trade\Trade.mqh> 
//---     MQL4   
#ifdef __MQL5__ 
#define Ask    SymbolInfoDouble(_Symbol,SYMBOL_ASK)
#define Bid    SymbolInfoDouble(_Symbol,SYMBOL_BID)
#endif 
//--- input parameters
input int      shift=5;    //    
input double   lot=1;      //  
//---
CTrade trade;
//---  SYMBOL_TRADE_STOPS_LEVEL  SYMBOL_TRADE_FREEZE_LEVEL
int freeze_level,stops_level;
//---   
bool buy_done;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   Print(__FILE__);
//---    
   buy_done=false;
//---    
   ENUM_SYMBOL_TRADE_EXECUTION execution_mode=(ENUM_SYMBOL_TRADE_EXECUTION)
                                              SymbolInfoInteger(_Symbol,SYMBOL_TRADE_EXEMODE);
   PrintFormat("SYMBOL_TRADE_EXECUTION=%s",EnumToString(execution_mode));
//---    ,        
   freeze_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_FREEZE_LEVEL);
   if(freeze_level!=0)
     {
      PrintFormat("SYMBOL_TRADE_FREEZE_LEVEL=%d:     ,"+
                  "   %d    ",freeze_level,freeze_level);
     }
//---     StopLoss  Takeprofit
   stops_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
   if(stops_level!=0)
     {
      PrintFormat("SYMBOL_TRADE_STOPS_LEVEL=%d: StopLoss  TakeProfit  "+
                  "   %d    ",stops_level,stops_level);
     }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    ,     
   if(buy_done)
      return;
//---
   int start=stops_level-shift;
//---     ,      SL  1  
   for(int i=1;i<stops_level+shift;i++)
     {
      double buy_stop=NormalizeDouble(Ask+200*_Point,_Digits);
      //---   TakeProfit    Bid (StopLoss   BUY    )
      double sl=NormalizeDouble(buy_stop-(i+start)*_Point,_Digits);
      //---       StopLoss
      int delta=(int)MathRound((buy_stop-sl)/_Point);
      //---  
      string msg=StringFormat("%d. BuyStop %.1f %s at %.5f SL=%.5f (Open-StopLoss=%d points)",
                              i,lot,_Symbol,buy_stop,sl,delta);
      //---         
      Print(msg);
      //---  ,     StopLoss
      int loss=(int)MathRound((buy_stop-sl)/_Point);
      //---   BUYSTOP  
      if(trade.BuyStop(lot,buy_stop,_Symbol,sl,0,0,0,StringFormat("StopLoss=%d points",loss)))
        {
         //---  
         PrintFormat("BuyStop %.1f %s done at %.5f with StopLoss=%.5f (SYMBOL_TRADE_STOPS_LEVEL=%d)",
                     lot,_Symbol,buy_stop,sl,stops_level);
         //---       BUYSTOP
         break;
        }
      //---   ,    100 ms    
      Sleep(1000);
     }
   Print(" --------- ");
//---    BuyLimt   TakeProfit
   start=stops_level-shift;
//---    ,      TP  1   
   for(int i=1;i<stops_level+shift;i++)
     {
      double buy_limit=NormalizeDouble(Ask-200*_Point,_Digits);
      //---   TakeProfit    Bid (StopLoss   BUY    )
      double tp=NormalizeDouble(buy_limit+(i+start)*_Point,_Digits);
      //---    TakeProfit    
      int delta=(int)MathRound((tp-buy_limit)/_Point);
      //---  
      string msg=StringFormat("%d. BuyLimit %.1f %s at %.5f TP=%.5f (TakeProfit-Open=%d points)",
                              i,lot,_Symbol,buy_limit,tp,delta);
      //---         
      Print(msg);
      //---  ,     TakeProfit
      int profit=(int)MathRound((tp-buy_limit)/_Point);
      //---   BUYLIMIT  
      if(trade.BuyLimit(lot,buy_limit,_Symbol,0,tp,0,0,StringFormat("TakeProfit=%d points",profit)))
        {
         //---  
         PrintFormat("BuyLimit %.1f %s done at %.5f with TakeProfit=%.5f (SYMBOL_TRADE_STOPS_LEVEL=%d)",
                     lot,_Symbol,buy_limit,tp,stops_level);
         //---     "  "
         buy_done=true;
         //---       BUYLIMIT
         break;
        }
      //---   ,    100 ms    
      Sleep(1000);
     }
  }
//+------------------------------------------------------------------+
